//
// MiniGame
//    EggPacker  2.0+		\[XJ(2008/1/24)
//							written by RJ
//

#include "MiniGame.h"

#include "CChip.h"


int Input, EdgeInput ;      	//  ͏
int FrameStartTime ;        	//  UOeorŒpAԕۑpϐ

char DatFileName[] = "EggPacker.dat"; // nCXRAt@C

int iChrHand[ 15*5 ];			// LN^pnho^
int iStageHand;					// Xe[Wf[^pnh
int hVoice1;					// Wvp{CX
int hVoice2;					// JXp{CX
int hVoice3;					// AE`
int x_score = 0 ,y_score = 0;	// XRA\̈ʒu
int score = 0;					// XRA
int hi_score = 0;				// nCXRA


#define CL_TOP		12
#define CL_MIDDLE	12
#define CL_BOTTOM	12
#define CHIP_MAX	(CL_BOTTOM + CL_BOTTOM + CL_BOTTOM)

CChip	*pChip[ CHIP_MAX ];			// LN^[NXQ
int spMy   = (-1);
int spBall = (-1);

// ANVTvvOC֐
int ActMain( void ) ;

int SetStage( void );
int SaveHiscore( int Score );
int LoadHiscore( void );

enum {SP_TOP ,SP_MIDDLE ,SP_BOTTOM} SPRITE_PLANE;

// ------------------------------------------------------------------
// Chip֌W
// ------------------------------------------------------------------

// 󂢂ĂChipXgԍԂB󂢂ĂȂƂ(-1)ԂB
//  SP_TOPASP_MIDDLEASP_BOTTOM ŕ\D揇ʂw肷B
int GetEmptyIndex( int sp )
{
	int iRet = (-1);
	int iBegin = 0 , iEnd = 0;
	switch( sp ){
		case SP_BOTTOM:	//_zȂǔwiILN^
			iBegin = 0;
			iEnd   = CL_BOTTOM;
			break;
		case SP_MIDDLE:	// MyAGLȂǒʏ
			iBegin = CL_BOTTOM;
			iEnd   = CL_BOTTOM + CL_MIDDLE;
			break;
		case SP_TOP: // XRA\ȂǍőO
			iBegin = CL_BOTTOM + CL_MIDDLE;
			iEnd   = CHIP_MAX;
			break;
		default:
			MessageBox( NULL , "no index" , "GetEmpyIndex" , MB_OK );
			break;
	}
	for( int i = iBegin ; i < iEnd ; i++ ){
		if( pChip[ i ] == NULL ){
			iRet = i;
			break;
		}
	}
	return iRet;
}

// _\Jn
int SetScoreUp()
{
	int i = GetEmptyIndex( SP_TOP );
	if( i != (-1) ){
		pChip[ i ] = new CScoreEffect( 1 );
	}
	
	if( hi_score <= score ) hi_score = score;
	return 0;
}

// ~X\Jn
int SetScoreFail()
{
	int i = GetEmptyIndex( SP_TOP );
	if( i != (-1) ){
		pChip[ i ] = new CScoreEffect( 2 );
	}
	return 0;
}

// _o
int WakeupCloud()
{
	int i = GetEmptyIndex( SP_BOTTOM );
	if( i != (-1) ){
		pChip[ i ] = new CCloudEffect();
	}
	return 0;
}

// JXo
int WakeupCrow()
{
	int i = GetEmptyIndex( SP_MIDDLE );
	if( i != (-1) ){
		pChip[ i ] = new CCrow();
	}
	return 0;
}

// Ao
int WakeupWet()
{
	int i = GetEmptyIndex( SP_TOP );
	if( i != (-1) ){
		pChip[ i ] = new CActEffect( 0 );
	}
	return 0;
}


// Juo
int WakeupRadish()
{
	int i = GetEmptyIndex( SP_MIDDLE );
	if( i != (-1) ){
		pChip[ i ] = new CRadish();
	}
	return 0;
}


// ------------------------------------------------------------------
// ------------------------------------------------------------------

// ChipXg̉
int FreeChipList()
{
    int i = 0;
    if( pChip ){
        for( i = 0 ; i< CHIP_MAX ; i++ ){
            if( pChip[ i ] ){
                delete pChip[ i ];
                pChip[ i ] = NULL;
            }
        }
    }
    return 0;
}


// ChipQƂłlf[^
CChip *GetMyChip()
{
	return pChip[ spMy ];
}

// ChipQƂł{[f[^
CChip *GetBallChip()
{
	return pChip[ spBall ];
}

// ------------------------------------------------------------------
// ------------------------------------------------------------------

// nCXRAo^
int SaveHiscore( int Score )
{
	int sc = Score;
	BYTE data[8] = {0,0,0,0,0,0,0,0};
	memcpy( data , (BYTE*)&sc , sizeof(int ) );
	
	FILE *fp = fopen( DatFileName , "w" );
	if( fp ){
		fwrite( (BYTE*)data , sizeof(data) , 1 , fp );
	}
}

// nCXRAĂяo
int LoadHiscore( void )
{
	BYTE data[8] = {0,0,0,0,0,0,0,0};
	int sc = 0;
	FILE *fp = fopen( DatFileName , "r" );
	if( fp ){
		fread( (BYTE*)data , sizeof(data) , 1 , fp );
		sc = *(int*)data;
	}
	return sc;
}

// WinMain֐
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpCmdLine, int nCmdShow )
{

	#ifndef DEBUG
	// Oo͂s
	SetOutApplicationLogValidFlag( FALSE );
	#endif

    ChangeWindowMode( TRUE ) ;

	// ACR̕ύX
	SetWindowIconID( 0x101 );

    // cwCȕ
    if( DxLib_Init() == -1 ) return -1 ;

	// ^CgύX
	SetMainWindowText( "EggPacker Open" );

    // ANVQ[̃C֐Ă
    ActMain() ;

    // cwCǔn
    DxLib_End() ;

    // I
    return 0 ;
}


// Q[tB[h쐬
int SetStage( void )
{
	
    // ʂ̃NA
    ClearDrawScreen() ;

	// 
	for( int i = 0 ; i < MAP_BOTTOM/CHIP_SIZE ; i++ ){
		for( int j = 0 ; j < SCREEN_WIDTH/CHIP_SIZE ; j++ ){
			DrawGraph( j*CHIP_SIZE , i*CHIP_SIZE , iChrHand[ CHIP_SKY ] , FALSE );
		}
	}

	// n	
	for( int i = 0 ; i < SCREEN_WIDTH/CHIP_SIZE ; i++ ){
		DrawGraph( i*CHIP_SIZE , MAP_BOTTOM , iChrHand[ 30 ] , TRUE );
		DrawGraph( i*CHIP_SIZE , MAP_BOTTOM+CHIP_SIZE , iChrHand[ CHIP_GROUND ] , FALSE );
	}


	// wTCỸOtBbN쐬
	iStageHand = MakeGraph( SCREEN_WIDTH , SCREEN_HEIGHT );

	// ʃf[^̎肱
	GetDrawScreenGraph( 0 , 0 , SCREEN_WIDTH , SCREEN_HEIGHT , iStageHand ) ;

	return 0;
}

// `bv(LN^[)\
int PutChip( float x , float y , int no )
{
	return DrawExtendGraph( ( int )( x*2.0f ) , ( int )( y*2.0f ) , ( int )( x*2.0f )+CHIP_SIZE*2 , ( int )( y*2.0f )+CHIP_SIZE*2 , iChrHand[ no ] , TRUE );
}
// _p {ɂĕ\
int PutChip2( float x , float y , int no )
{
	return DrawExtendGraph( ( int )( x*2.0f ) , ( int )( y*2.0f ) , ( int )( x*2.0f )+CHIP_SIZE*4 , ( int )( y*2.0f )+CHIP_SIZE*2 , iChrHand[ no ] , TRUE );
}


char szURL[] = "http://www.ric.hi-ho.ne.jp/tangled-tales/";


int SubTitle( void )
{
	//-------------------------------------------------------------
	//Q[
	//-------------------------------------------------------------
	DrawExtendGraph( 0,0 , SCREEN_WIDTH*2 ,SCREEN_HEIGHT*2 , iStageHand , FALSE );
// `悷镶̃TCYݒ
	SetFontSize( 24 ) ;
	
	char szStr[] = "";
	int x = 20;
	int Cr0 = GetColor( 90 , 80 , 90 );
	int Cr1 = GetColor( 50 , 120 , 50 );
	int Cr2 = GetColor( 10 , 10 , 200 );
	int Cr3 = GetColor( 240 , 240 ,240 );
	
	int wd  = GetDrawStringWidth( szStr , lstrlen(szStr) );
	
	DrawBox( x-10 , 5 , wd+25 ,32*10 , Cr3 , TRUE );
	
	// ̕`
	DrawString( x , 10 ,   "@ EggPacker        ver 2.0+      :RJ" , Cr1 );
	DrawString( x , 32*1 , szStr , Cr2 );
	DrawString( x , 32*2 , "Eœ Z ŃWv鉩F𑀍B" , Cr0 );
	DrawString( x , 32*3 , "^}SAē˂邱Ƃœ_ɂȂ܂B" , Cr0 );
	DrawString( x , 32*4 , "ł^}S𗎂Ƃ0_I" , Cr0 );
	DrawString( x , 32*5 , "Q[I[o[͂Ȃ̂ŁA" , Cr0 );
	DrawString( x , 32*6 , "CyɃ`WĂB" , Cr0 );
	DrawString( x , 32*7 , "Q[IESCL[ŁB" , Cr0 );
	DrawString( x , 32*8 , szStr , Cr2 );
	PutChip( x/2 , 10/2 ,  CHIP_EGG );
	PutChip( (wd-CHIP_SIZE)/2 , 32*7/2 ,  CHIP_MY_F );
	
	SetFontSize( 16 ) ;
	int wd2 = GetDrawStringWidth( szURL , lstrlen(szURL) );
	DrawString( x + wd-wd2 , 32*9 , szURL , Cr0 );
    ScreenFlip() ;

	WaitKey();
	SetFontSize( 16 ) ;
	
	return 0;
}

// ANVTvvOC
int ActMain( void )
{


    // `𗠉ʂɃZbg
    SetDrawScreen( DX_SCREEN_BACK ) ;

	// ߐFݒ肷 
	SetTransColor(  128 , 0 , 192  );
	
	// ChipLN^[Ǎ
	if( LoadDivGraph( "Media\\chara.bmp" , 15*5 , 15 , 4 ,16 , 16 , iChrHand ) == (-1) )
		return (-1);


	hVoice1 = LoadSoundMem( "Media\\VoiceTei.wav" );
	if(	hVoice1 == (-1) )
		return (-1);
		
	ChangeVolumeSoundMem( 0x20 , hVoice1 );

	hVoice2 = LoadSoundMem( "Media\\VoiceKaa.wav" );
	if(	hVoice2 == (-1) )
		return (-1);
		
	ChangeVolumeSoundMem( 0x20 , hVoice2 );

	hVoice3 = LoadSoundMem( "Media\\VoiceOuch.wav" );
	if(	hVoice3 == (-1) )
		return (-1);
		
	ChangeVolumeSoundMem( 0x20 , hVoice3 );

 
    // M҂Ȃ
    SetWaitVSyncFlag( FALSE ) ;

    // 60FPSŒpAԕۑpϐ݂̃JEglɃZbg
    FrameStartTime = GetNowCount() ;


	hi_score = LoadHiscore();


    // ͏Ԃ̏
    Input = 0 ;
    EdgeInput = 0 ;

	// eChip
	memset( pChip , 0 , sizeof(CChip*)*10 );
    // LN^̓o^
	// vC[
	spMy   = GetEmptyIndex( SP_MIDDLE );// CfbNX擾炷ɓo^邱
	if( spMy == (-1) ) return (-1);
	pChip[ spMy ] = new CPlayer();
	// ^}S{[
	spBall = GetEmptyIndex( SP_MIDDLE );
	if( spBall == (-1) ) return (-1);
	pChip[ spBall ] = new CBall();
	// wȋz(ŏɐݒ肵ȂƍŔwʂɂȂȂ)
	int iSun = GetEmptyIndex( SP_BOTTOM );
	if( iSun == (-1) ) return (-1);
	pChip[ iSun ] = new CSun();


    // ʂ̃NA
    ClearDrawScreen() ;

	SetStage();

	char str[] = "SCORE";
	y_score = (MAP_BOTTOM+CHIP_SIZE*3 + 5)*2;
	x_score = (5 + GetDrawStringWidth( str , lstrlen(str) ) + 8)*2;

	// ^Cgʏ
	SubTitle();
	
	int EffectCount = 0; // ʌʂGopJEg
	//-------------------------------------------------------------
    // C[vJnAdrbL[ŊOɏo
	//-------------------------------------------------------------
    while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 )
    {
        // Xe[W̕`
		DrawExtendGraph( 0,0 , SCREEN_WIDTH*2 ,SCREEN_HEIGHT*2 , iStageHand , FALSE );


        // P/UOb܂ő҂
        while( GetNowCount() - FrameStartTime < (1000 / 60) ){}

        // ݂̃JEglۑ
        FrameStartTime = GetNowCount() ;

        // ͏ԂXV
        {
            int i = 0;

            // pbhPƃL[{[h͂𓾂
            i = GetJoypadInputState( DX_INPUT_KEY_PAD1 ) ;

            // GbW͂Zbg
            EdgeInput = i & ~Input ;

            // ͏Ԃ̕ۑ
            Input = i ;
        }

		EffectCount = (EffectCount + 1) % 600;
		// 400ɈA_o
		if( EffectCount == 10 ){
			WakeupCloud();
		}
		// JXo
		if( EffectCount == 500 ){
			WakeupCrow();
		}
		// Juo
		if( EffectCount == 300 ){
			if( GetRand(4) < 3 )
				WakeupRadish();
		}


		// LN^[Chip̏
		for( int i = 0 ; i < CHIP_MAX ; i++ ){
			if( pChip[ i ] ){
				pChip[ i ]->Move();
				pChip[ i ]->Put();
				if( !pChip[ i ]->GetLive() ){ // Chip񂾂
					delete pChip[ i ];
					pChip[ i ] = NULL;
				}
			}
		}


		DrawFormatString( x_score , y_score , GetColor( 255 , 255 , 255 ) , "SCORE  %.4d   HI-SCORE %.4d" , score , hi_score );

        // ʂ̍XV
        ScreenFlip() ;
    }

    // ChipXg̉
    FreeChipList();

	// nCXRÃZ[u
	SaveHiscore( hi_score );

    // I
    return 0 ;
}

